<?php


const paw_kassa_VAT0     = '1104';  // НДС 0%
const paw_kassa_VAT10    = '1103';  // НДС 10%
const paw_kassa_VAT18    = '1102';  // НДС 18%
const paw_kassa_VATNOVAT = '1105';  // НДС не облагается
const paw_kassa_VATWR10  = '1107';  // НДС с рассч. ставкой 10%
const paw_kassa_VATWR18  = '1106';  // НДС с рассч. ставкой 18%

function monetaPayURLResponse($mnt_id, $mnt_transaction_id, $mnt_data_integrity_code, $success = false,
							  $repeatRequest = false, $echo = true, $die = true, $kassa_inventory = null,
							  $kassa_customer = null, $kassa_delivery = null)
{
	if ($success === true)
		$resultCode = '200';
	elseif ($repeatRequest === true)
		$resultCode = '402';
	else
		$resultCode = '500';
	$mnt_signature = md5($resultCode.$mnt_id.$mnt_transaction_id.$mnt_data_integrity_code);
	$response = '<?xml version="1.0" encoding="UTF-8" ?>'."\n";
	$response .= "<MNT_RESPONSE>\n";
	$response .= "<MNT_ID>{$mnt_id}</MNT_ID>\n";
	$response .= "<MNT_TRANSACTION_ID>{$mnt_transaction_id}</MNT_TRANSACTION_ID>\n";
	$response .= "<MNT_RESULT_CODE>{$resultCode}</MNT_RESULT_CODE>\n";
	$response .= "<MNT_SIGNATURE>{$mnt_signature}</MNT_SIGNATURE>\n";
	if (!empty($kassa_inventory) || !empty($kassa_customer) || !empty($kassa_delivery))
	{
		$response .= "<MNT_ATTRIBUTES>\n";
		foreach (array('INVENTORY' => $kassa_inventory, 'CUSTOMER' => $kassa_customer, 'DELIVERY' => $kassa_delivery) as $k => $v)
			if (!empty($v))
				$response .= "<ATTRIBUTE><KEY>{$k}</KEY><VALUE>{$v}</VALUE></ATTRIBUTE>\n";
		$response .= "</MNT_ATTRIBUTES>\n";
	}
	$response .= "</MNT_RESPONSE>\n";
	if ($echo === true)
	{
		header("Content-type: application/xml");
		echo $response;
	}
	else
		return $response;
	if ($die === true)
		die;
	return '';
}

function getVar($name){
	$value = false;
	if(isset($_POST[$name])){
		$value = $_POST[$name];
	}else if(isset($_GET[$name])){
		$value = $_GET[$name];
	}

	return $value;
}

define('MODX_API_MODE', true);
require dirname(dirname(dirname(dirname(dirname(__FILE__))))) . '/index.php';

$modx->getService('error', 'error.modError');
$modx->setLogLevel(modX::LOG_LEVEL_ERROR);
$modx->setLogTarget('FILE');

/** @var minishop2 $miniShop2 */
$miniShop2 = $modx->getService('minishop2');
$miniShop2->loadCustomClasses('payment');

if (!class_exists('PayAnyWay')) {
	exit('Error: could not load payment class "PayAnyWay".');
}

$handler = new PayAnyWay($modx->newObject('msOrder'));
$mnt_secret = $handler->modx->getOption('MNT_SECRET');

$mnt_id = getVar('MNT_ID');
$mnt_transaction_id = getVar('MNT_TRANSACTION_ID');
$mnt_operation_id = getVar('MNT_OPERATION_ID');
$mnt_amount = getVar('MNT_AMOUNT');
$mnt_currency_code = getVar('MNT_CURRENCY_CODE');
$mnt_subscriber_id = getVar('MNT_SUBSCRIBER_ID');
$mnt_test_mode = getVar('MNT_TEST_MODE');
$mnt_signature = getVar('MNT_SIGNATURE');

$mnt_signature_calculated = md5($mnt_id . $mnt_transaction_id . $mnt_operation_id . $mnt_amount . $mnt_currency_code . $mnt_subscriber_id . $mnt_test_mode . $mnt_secret);

if ($mnt_signature_calculated == $mnt_signature)
{
	$miniShop2->changeOrderStatus($mnt_transaction_id, 2);

		/** @var msOrder $orderObj */
		$orderObj = $modx->getObject('msOrder', $mnt_transaction_id);
		$order = $orderObj->toArray();
		$kassa_delivery = $order['delivery_cost'];
		/** @var msOrderProduct[] $orderProduct */
		$orderProduct = $modx->getCollection('msOrderProduct', array('order_id' => $mnt_transaction_id));
		// $clientEmail = $handler->modx->config['emailsender'];
		$profile = $modx->getObject('modUserProfile', array('internalKey' => $orderObj->get('user_id')));
		$clientEmail = $profile->get('email');
		$inventoryPositions = [];
		foreach ($orderProduct as $productObject)
		{
			$product = $productObject->toArray();
			$inventoryPositions[] = array(
				'name' => trim(preg_replace("/&?[a-z0-9]+;/i", "", htmlspecialchars($product['name']))),
				'quantity' => $product['count'],
				'price' => $product['price'],
				'vatTag' => paw_kassa_VATNOVAT
			);
		}
		$kassa_inventory = json_encode($inventoryPositions);
		monetaPayURLResponse($mnt_id, $mnt_transaction_id, $mnt_secret, true, false, true, true, $kassa_inventory,
			$clientEmail, $kassa_delivery);                                            							// 200
} else
{
	print "FAIL";
	die;
}