<?php

if (!class_exists('msPaymentInterface')) {
	require_once dirname(dirname(dirname(__FILE__))) . '/model/minishop2/mspaymenthandler.class.php';
}

class PayAnyWay extends msPaymentHandler implements msPaymentInterface
{
	public $modx;

	function __construct(xPDOObject $object, $config = array())
	{
		$this->modx = &$object->xpdo;
	}

	public function send(msOrder $order)
	{
		$link = $this->getPaymentLink($order);
		return $this->success('', array('redirect' => $link));
	}

	public function getPaymentLink(msOrder $order)
	{
		$mnt_id = $this->modx->getOption('MNT_ID');
		$mnt_transaction_id = $order->get('id');
		$mnt_amount = number_format($order->get('cost'), 2, '.', '');
		$mnt_currency_code = $this->modx->getOption('MNT_CURRENCY_CODE');
		$mnt_test_mode = $this->modx->getOption('MNT_TEST_MODE');
		$mnt_server = ($this->modx->getOption('MNT_DEMO') == '1') ? 'demo.moneta.ru' : 'www.payanyway.ru';
		$request = array(
			'MNT_ID' => $mnt_id,
			'MNT_TRANSACTION_ID' => $mnt_transaction_id,
			'MNT_AMOUNT' => $mnt_amount,
			'MNT_CURRENCY_CODE' => $mnt_currency_code,
			'MNT_TEST_MODE' => $mnt_test_mode,
			'MNT_SIGNATURE' => md5(
				$mnt_id.
				$mnt_transaction_id.
				$mnt_amount.
				$mnt_currency_code.
				$mnt_test_mode.
				$this->modx->getOption('MNT_SECRET')
			)
		);
		$link = 'https://'.$mnt_server.'/assistant.htm?'.http_build_query($request);
//		$link = 'http://localhost:8080/assistant.htm?'.http_build_query($request);
		return $link;
	}


}
